#ifndef _N76E003_CONF_H_
#define _N76E003_CONF_H_
/*----------------------------------------------------------------------------
 *      N76E003 configuration part BEGIN
 *---------------------------------------------------------------------------*/

//-------- <<< Use Configuration Wizard in Context Menu >>> -----------------
// =============================
//   <o.7>Boot Options
//        <0=> Boot from LDROM
//        <1=> Boot from APROM
//   <i> This bit defines from which block that MCU re-boots after resets except software reset.
#ifndef CONFIG0_b7
    #define CONFIG0_b7       0x80
#endif
// =============================
//   <o.0..2>LDROM size Options
//      <7=> No LDROM
//      <6=> LDROM = 1KB
//      <5=> LDROM = 2KB
//      <4=> LDROM = 3KB
//      <3=> LDROM = 4KB
#ifndef CONFIG1_b2to0
    #define CONFIG1_b2to0       0x07
#endif
// =============================
//   <o.4..5>Brown-out Detector Options
//      <3=> VBOD is 2.2V
//      <2=> VBOD is 2.7V
//      <1=> VBOD is 3.7V
//      <0=> VBOD is 4.4V
#ifndef CONFIG2_b5to4
    #define CONFIG2_b5to4       0x30
#endif
// =============================
// <q>Brown-out Detect Enable
#ifndef CONFIG2_b7_Mask
    #define CONFIG2_b7_Mask     1
#endif
#ifndef CONFIG2_b7
    #define CONFIG2_b7     ((CONFIG2_b7_Mask)<<7)
#endif
// =============================
// <q>Brown-out Reset Enable
// <i> This bit decides whether a brown-out reset is caused by a power drop below VBOD.
#ifndef CONFIG2_b2_Mask
    #define CONFIG2_b2_Mask     1
#endif
#ifndef CONFIG2_b2
    #define CONFIG2_b2     ((CONFIG2_b2_Mask)<<2)
#endif
// =============================
// <q>Brown-out inhibiting IAP
// <i> This bit decides whether IAP erasing or programming is inhibited by brown-out status. This bit is valid only when brown-out detection is enabled.
#ifndef CONFIG2_b3_Mask
    #define CONFIG2_b3_Mask     1
#endif
#ifndef CONFIG2_b3
    #define CONFIG2_b3     ((CONFIG2_b3_Mask)<<3)
#endif
// =============================
//   <o.4..7>WDT Options
//      <15=> Disabled
//      <5=> Enable and stop running in Idle/Power-down mode
//      <0=> Enable and keep running in Idle/Power-down mode
#ifndef CONFIG4_b7to4
    #define CONFIG4_b7to4       0xF0
#endif
// =============================
// <q>Security Lock
// <i> When the Whole Flash Memory is locked,Their contents read through a parallel Writer or ICP programmer will be all blank (FFH).Programming to Flash Memory is invalid.
#ifndef CONFIG0_b1_Mask
    #define CONFIG0_b1_Mask     0
#endif
#ifndef CONFIG0_b1
    #define CONFIG0_b1     ((CONFIG0_b1_Mask^0x01)<<1)
#endif
// =============================
// <q>OCD Enable
// <i>If MCU run in OCD debug mode and OCDEN = 0, hard fault reset will be disabled and only Hard F flag be asserted.
#ifndef CONFIG0_b4_Mask
    #define CONFIG0_b4_Mask     0
#endif
#ifndef CONFIG0_b4
    #define CONFIG0_b4     ((CONFIG0_b4_Mask^0x01)<<4)
#endif
// =============================
//   <o.2>P2.0/RST Pin Function
//        <0=> P2.0 as the input-only pin
//        <1=> P2.0 as the external reset pin
#ifndef CONFIG0_b2
    #define CONFIG0_b2       0x04
#endif
// =============================
//   <o.5>PWM output state under OCD halt
//        <0=> PWM continues
//        <1=> Tri-state
//  <i>This bit decides the output state of PWM when OCD halts CPU
#ifndef CONFIG0_b5
    #define CONFIG0_b5       0x20
#endif

//------------- <<< end of configuration section >>> -----------------------
#ifndef  CONFIG0
    #define CONFIG0     (0x49|CONFIG0_b7|CONFIG0_b5|CONFIG0_b4|CONFIG0_b2|CONFIG0_b1)
#endif
#ifndef  CONFIG1
    #define CONFIG1     (0xF8|CONFIG1_b2to0)
#endif
#ifndef  CONFIG2
    #define CONFIG2     (0x43|CONFIG2_b7|CONFIG2_b5to4|CONFIG2_b3|CONFIG2_b2)
#endif
#ifndef  CONFIG3
    #define CONFIG3     (0xFF)
#endif
#ifndef  CONFIG4
    #define CONFIG4     (0x0F|CONFIG4_b7to4)
#endif

#endif    //_N76E003_CONF_H_


