/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2017 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/

//***********************************************************************************************************
//  Nuvoton Technoledge Corp.
//  Website: http://www.nuvoton.com
//  E-Mail : MicroC-8bit@nuvoton.com
//  Date   : Apr/21/2017
//***********************************************************************************************************

//***********************************************************************************************************
//  File Function: N76E003 CONFIG program demo code
//***********************************************************************************************************

#include "N76E003.h"
#include "Common.h"
#include "SFR_Macro.h"
#include "Function_define.h"
#include "N76E003_Conf.h"

bit  BIT_TMP;
code unsigned char au8Config[5] = {CONFIG0, CONFIG1, CONFIG2, CONFIG3, CONFIG4};


void IAP_Check_Config(void)
{
    unsigned char i;
    set_IAPEN;

    for (i = 0; i < 5; i++)
    {
        IAPAL = i;
        IAPAH = 0x00;
        IAPFD = 0x00;
        IAPCN = 0xC0;                       //Read config command
        set_IAPGO;

        if (IAPFD  != au8Config[i])
            break;
    }

    if (i < 5)
    {
        set_CFUEN;
        IAPAL = 0x00;
        IAPAH = 0x00;
        IAPFD = 0xFF;
        IAPCN = 0xE2;                       //Erase config command
        set_IAPGO;

        for (i = 0; i < 5; i++)
        {
            IAPAL = i;
            IAPAH = 0x00;
            IAPFD = au8Config[i];
            IAPCN = 0xE1;                   //Write config command
            set_IAPGO;
        }
        clr_CFUEN;
        clr_IAPEN;
        EA = 0;
        TA = 0xAA;
        TA = 0x55;
        CHPCON &= 0xFD;                     //reboot from APROM
		
        TA = 0xAA;
        TA = 0x55;
        CHPCON |= 0x80;//The new Config values of the MCU need to be restarted to take effect
        while(1);
    }

    clr_IAPEN;

}

//-----------------------------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------------------------
void main(void)
{
    IAP_Check_Config();
    while (1);
}
//-----------------------------------------------------------------------------------------------------------

